#-###################################################
#
# This converts the boxes in your original code to unique box numbers found on the conversion test
# document found in TestDoc.zip.
#
# Also open in the editor the companion file 'ConvertWebTestBoxesToOrigBoxes.rbw' to
# convert your Ruby code boxes back to their original values as found on your original document.
#
# Just select and copy the Ruby code that you want to check conversion on or that you want to tweak
# so that it will convert successfully, to the clipboard [Ctrl-c], then run this script file via F5.
#
# 1) Your Ruby code will now have all boxes converted over to TestDoc.zip boxes and will be in
#     the clipboard,  Paste [Ctrl-v] the code into the TestDoc Ruby file so you can edit it and get it
#     to convert, or to see if it will convert.
#
# 2) You will see boxes printed to the output pane window, these are the original boxes found
# 	in your Ruby code, you will use them when converting the Ruby code boxes back to their
#	original values - copy them to the variable 'origBoxArray' found in the companion file
#	'ConvertWebTestBoxesToOrigBoxes.rbw'.
#
# 3) Once you can convert your Ruby code, just copy it to the clipboard, then run [F5]
# 	the companion file 'ConvertWebTestBoxesToOrigBoxes.rbw' which copies your code from
#	the clipboard and converts the test boxes back to the original values and copies back to the
#	clipboard.
#
# 4) If you left your Ruby code selected in the original code file, just press Ctrl-v to replace it
#	with your code that will now convert, else select the code again then paste.
#
#-###################################################

require 'tk'

inputStr = TkClipboard.get(nil)

#print inputStr

page_num_array = Array.new
boxArray = Array.new
box = String.new
output_str = String.new

#-######################################################
#
# THIS WOULD BE THE ONLY THING TO CHANGE IN THIS FILE:
#
# TestDoc has 100 boxes on page 1, if you make a new copy, or use your own test doc you would change
# this value accordingly for your page 1 box amount.
#
boxLimit = 100

#-######################################################

num = '1'

inputStr.each { |code_line|
	code_line.scan(/(box)(\d+)(_)(\d+)/) {
		page_num_array.push([$2.to_i,$4.to_i]) unless page_num_array.include?([$2.to_i,$4.to_i])
	}
}

# Now sort the two-dimensional page_num_array.
page_num_array.sort!

# Now put the box parts back together and insert into the Box List widget.
page_num_array.each_index { |index|
	boxArray.push("box#{page_num_array[index][0]}_#{page_num_array[index][1]}")
}

# Print out the sorted box array for use when converting box nums back to original values:
print boxArray.join(',')

unless (boxArray.length > boxLimit)

	inputStr.each { |code_line|
	
		code_line.gsub!(/(box)(\d+)(_)(\d+)/) { |box|

			# Replace box with incremental box number.
			$1 + '1' + $3 + (boxArray.index(box) + 1).to_s
		}
		
		output_str += code_line
	}
else
	print "RAN OUT OF BOXES DUDE\DUDETTE!!"
end

#print output_str

#
# TkClipboard.set first clears the clipboard.
#
TkClipboard.set(output_str.empty? ? '' : output_str, nil)
